#include <iostream>
#include <mysql++>


int main() {
  // The full format for the Connection constructor is
  // Connection(cchar *db, cchar *host="", 
  //            cchar *user="", cchar *passwd="") 
  // You may need to specify some of them if the database is not on
  // the local machine or you database username is not the same as your
  // login name, etc..
  try {
		Connection con("wisenet", "job247a.bradley.edu", "wisedb", "nojim...");
		Query query = con.query();
		// This creates a query object that is bound to con.

		
		int moteid;
		int data_type;
		int data_value;
		char description[50];



		cout << "Database: wisenet:\n\n";
		cout << "test_data.logid: (Auto-increment)\n";
		cout << "test_data.timestamp: (now())\n";
		cout << "test_data.moteid: ";
		cin  >> moteid;
		cout << "test_data.description: (put in quotes)\n";
		cout << "light, temperature, humidity, battery  :";
		cin  >> description;
		cout << "DATA: ";
		cin  >> data_value;
		
		query << "select data_type from data_types where description = " << description;
		
		Result res=query.store();
		Result::iterator i;
		i=res.begin();
		Row row = *i;
		data_type = row["data_type"];
		
		cout << "That data type is : " << data_type << endl;
		query.reset();
		query << "insert into test_data (logid,moteid,timestamp,data_type,data_value) values(%0q,%1q,%2,%3,%4)";
		query.parse();

		query.store (0,moteid,"now()",data_type,data_value);
		cout << "Inserted row into test_data successfully\n\n";
		cout << "Here is what was inserted:\n";
		cout << "logid\n";
		cout << "moteid=" << moteid << endl;
		cout << "timestamp\n";
		cout << "data_type=" << data_type << endl;
		cout << "data_value=" << data_value << endl;
  } 
  catch (BadQuery er){ // handle any connection 
                         // or query errors that may come up
    cerr << "Error: " << er.error <<  endl;
	 

    return -1;

  } catch (BadConversion er) {
    // we still need to cache bad conversions incase something goes 
    // wrong when the data is converted into stock
    cerr << "Error: Tried to convert \"" << er.data << "\" to a \""
	 << er.type_name << "\"." << endl;
    return -1;
  }
	return 0;
}





/*		query << "select data_type,description from data_types";
		// You can write to the query object like you would any other ostrem

		Result res = query.store();
		// Query::store() executes the query and returns the results

		cout << "Query: " << query.preview() << endl;
		// Query::preview() simply returns a string with the current query
		// string in it.

		cout << "Records Found: " << res.size() << endl << endl;
  
*/